"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
Object.defineProperty(exports, "__esModule", { value: true });
const vscode_extension_tester_1 = require("vscode-extension-tester");
const chai_1 = require("chai");
describe("Тесты плагина PVS-Studio для VSCode", function () {
    this.timeout(10000);
    let view;
    before(() => __awaiter(this, void 0, void 0, function* () {
        this.timeout(8000);
        // open a sample web view
        yield new vscode_extension_tester_1.Workbench().executeCommand("PVS-Studio: Show Window");
        // задержка нужна, иначе селениум упадет
        yield new Promise((res) => {
            setTimeout(res, 4000);
        });
        // init the WebView page object
        view = new vscode_extension_tester_1.WebviewView();
        // switch webdriver into the webview iframe, now all webdriver commands are
        // relative to the webview document's root
        // make sure not to try accessing elements outside the web view while switched inside and vice versa
        yield view.switchToFrame();
    }));
    after(() => __awaiter(this, void 0, void 0, function* () {
        // after we are done with the webview, switch webdriver back to the vscode window
        yield view.switchBack();
        yield new vscode_extension_tester_1.EditorView().closeAllEditors();
    }));
    it("Запуск анализа без открытого проекта", () => __awaiter(this, void 0, void 0, function* () {
        const noProjectMessage = "The project directory is not open";
        console.log("Ищем кнопку старта анализа");
        const startAnalysisBtn = yield view.findWebElement(vscode_extension_tester_1.By.xpath(`.//button[text()="Analyze project"]`));
        console.log("Кликаем на кнопку старта анализа");
        yield startAnalysisBtn.click();
        console.log("Переключаемся с вебвьюхи на общее окно VSCode");
        view.switchBack();
        console.log("Ищем нотификашки");
        const workbench = new vscode_extension_tester_1.Workbench();
        const notifications = yield workbench.getNotifications();
        console.log(`Ищем нотификашку с сообщением ${noProjectMessage}`);
        const noProjectNotification = notifications.find((n) => __awaiter(this, void 0, void 0, function* () { return (yield n.getMessage()).includes(noProjectMessage); }));
        console.log("Проверяем, что нашли такую нотификашку");
        (0, chai_1.expect)(noProjectNotification).not.equal(undefined);
    }));
});
//# sourceMappingURL=sample.js.map